Loading...
Searching...
No Matches
wayland::zxdg_toplevel_v6_t Class Reference

toplevel surface More...

`#include <wayland-client-protocol-unstable.hpp>`

Inheritance diagram for wayland::zxdg_toplevel_v6_t:
[legend]
Collaboration diagram for wayland::zxdg_toplevel_v6_t:
[legend]

## Public Types

enum class | wrapper_type { standard , display , foreign , proxy_wrapper }

## Public Member Functions

void | set_parent (zxdg_toplevel_v6_t const &parent)
| set the parent of this surface
void | set_title (std::string const &title)
| set surface title
void | set_app_id (std::string const &app_id)
| set application ID
void | show_window_menu (seat_t const &seat, uint32_t serial, int32_t x, int32_t y)
| show the window menu
void | move (seat_t const &seat, uint32_t serial)
| start an interactive move
void | resize (seat_t const &seat, uint32_t serial, zxdg_toplevel_v6_resize_edge const &edges)
| start an interactive resize
void | set_max_size (int32_t width, int32_t height)
| set the maximum size
void | set_min_size (int32_t width, int32_t height)
| set the minimum size
void | set_maximized ()
| maximize the window
void | unset_maximized ()
| unmaximize the window
void | set_fullscreen (output_t const &output)
| set the window as fullscreen on a monitor
void | set_minimized ()
| set the window as minimized
std::function< void(int32_t, int32_t, array_t)> & | on_configure ()
| suggest a surface change
std::function< void()> & | on_close ()
| surface wants to be closed
uint32_t | get_id () const
| Get the id of a proxy object.
std::string | get_class () const
| Get the interface name (class) of a proxy object.
uint32_t | get_version () const
| Get the protocol object version of a proxy object.
wrapper_type | get_wrapper_type () const
| Get the type of a proxy object.
void | set_queue (event_queue_t queue)
| Assign a proxy to an event queue.
wl_proxy * | c_ptr () const
| Get a pointer to the underlying C struct.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
| operator bool () const
| Check whether this wrapper actually wraps an object.
bool | operator== (const proxy_t &right) const
| Check whether two wrappers refer to the same object.
bool | operator!= (const proxy_t &right) const
| Check whether two wrappers refer to different objects.
void | proxy_release ()
| Release the wrapped object (if any), making this an empty wrapper.

## Static Public Attributes

static constexpr std::uint32_t | set_parent_since_version = 1
| Minimum protocol version required for the set_parent function.
static constexpr std::uint32_t | set_title_since_version = 1
| Minimum protocol version required for the set_title function.
static constexpr std::uint32_t | set_app_id_since_version = 1
| Minimum protocol version required for the set_app_id function.
static constexpr std::uint32_t | show_window_menu_since_version = 1
| Minimum protocol version required for the show_window_menu function.
static constexpr std::uint32_t | move_since_version = 1
| Minimum protocol version required for the move function.
static constexpr std::uint32_t | resize_since_version = 1
| Minimum protocol version required for the resize function.
static constexpr std::uint32_t | set_max_size_since_version = 1
| Minimum protocol version required for the set_max_size function.
static constexpr std::uint32_t | set_min_size_since_version = 1
| Minimum protocol version required for the set_min_size function.
static constexpr std::uint32_t | set_maximized_since_version = 1
| Minimum protocol version required for the set_maximized function.
static constexpr std::uint32_t | unset_maximized_since_version = 1
| Minimum protocol version required for the unset_maximized function.
static constexpr std::uint32_t | set_fullscreen_since_version = 1
| Minimum protocol version required for the set_fullscreen function.
static constexpr std::uint32_t | unset_fullscreen_since_version = 1
| Minimum protocol version required for the unset_fullscreen function.
static constexpr std::uint32_t | set_minimized_since_version = 1
| Minimum protocol version required for the set_minimized function.

## Detailed Description

toplevel surface

This interface defines an xdg_surface role which allows a surface to, among other things, set window-like properties such as maximize, fullscreen, and minimize, set application-specific metadata like title and id, and well as trigger user interactive operations such as interactive resize and move.

Definition at line 8257 of file wayland-client-protocol-unstable.hpp.

## Member Enumeration Documentation

## wrapper_type

enum class wayland::proxy_t::wrapper_type

strong inherited

Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator
standard | C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.
display | C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign

C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper | C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 116 of file wayland-client.hpp.

## Member Function Documentation

## c_ptr()

wl_proxy * wayland::proxy_t::c_ptr | ( |  | ) | const

inherited

Get a pointer to the underlying C struct.

Returns
  The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

## get_class()

std::string wayland::proxy_t::get_class | ( |  | ) | const

inherited

Get the interface name (class) of a proxy object.

Returns
  The interface name of the object associated with the proxy

## get_id()

uint32_t wayland::proxy_t::get_id | ( |  | ) | const

inherited

Get the id of a proxy object.

Returns
  The id the object associated with the proxy

## get_version()

uint32_t wayland::proxy_t::get_version | ( |  | ) | const

inherited

Get the protocol object version of a proxy object.

Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
  The protocol object version of the proxy or 0

## get_wrapper_type()

wrapper_type wayland::proxy_t::get_wrapper_type | ( |  | ) | const

inline inherited

Get the type of a proxy object.

Definition at line 302 of file wayland-client.hpp.

## move()

void zxdg_toplevel_v6_t::move | ( | seat_t const & | seat,
|  | uint32_t | serial
| ) |  |

start an interactive move

Parameters

  seat | the wl_seat of the user event
  serial | the serial of the user event

Start an interactive, user-driven move of the surface.

This request must be used in response to some sort of user action like a button press, key press, or touch down event. The passed serial is used to determine the type of interactive move (touch, pointer, etc).

The server may ignore move requests depending on the state of the surface (e.g. fullscreen or maximized), or if the passed serial is no longer valid.

If triggered, the surface will lose the focus of the device (wl_pointer, wl_touch, etc) used for the move. It is up to the compositor to visually indicate that the move is taking place, such as updating a pointer cursor, during the move. There is no guarantee that the device focus will return when the move is completed.

Definition at line 10000 of file wayland-client-protocol-unstable.cpp.

## on_close()

std::function< void()> & zxdg_toplevel_v6_t::on_close | ( |  | ) |

surface wants to be closed

The close event is sent by the compositor when the user wants the surface to be closed. This should be equivalent to the user clicking the close button in client-side decorations, if your application has any.

This is only a request that the user intends to close the window. The client may choose to ignore this request, or show a dialog to ask the user to save their data, etc.

Definition at line 10059 of file wayland-client-protocol-unstable.cpp.

## on_configure()

std::function< void(int32_t, int32_t, array_t)> & zxdg_toplevel_v6_t::on_configure | ( |  | ) |

suggest a surface change

Parameters

  width |
  height |
  states |

This configure event asks the client to resize its toplevel surface or to change its state. The configured state should not be applied immediately. See xdg_surface.configure for details.

The width and height arguments specify a hint to the window about how its surface should be resized in window geometry coordinates. See set_window_geometry.

If the width or height arguments are zero, it means the client should decide its own window dimension. This may happen when the compositor needs to configure the state of the surface but doesn't have any information about any previous or expected dimension.

The states listed in the event specify how the width/height arguments should be interpreted, and possibly how it should be drawn.

Clients must send an ack_configure in response to this event. See xdg_surface.configure and xdg_surface.ack_configure for details.

Definition at line 10054 of file wayland-client-protocol-unstable.cpp.

## operator bool()

wayland::proxy_t::operator bool | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## operator!=()

bool wayland::proxy_t::operator!= | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to different objects.

## operator==()

bool wayland::proxy_t::operator== | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to the same object.

## proxy_has_object()

bool wayland::proxy_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## proxy_release()

void wayland::proxy_t::proxy_release | ( |  | ) |

inherited

Release the wrapped object (if any), making this an empty wrapper.

Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
  foreign_display.cpp.

## resize()

void zxdg_toplevel_v6_t::resize | ( | seat_t const & | seat,
|  | uint32_t | serial,
|  | zxdg_toplevel_v6_resize_edge const & | edges
| ) |  |

start an interactive resize

Parameters

  seat | the wl_seat of the user event
  serial | the serial of the user event
  edges | which edge or corner is being dragged

Start a user-driven, interactive resize of the surface.

This request must be used in response to some sort of user action like a button press, key press, or touch down event. The passed serial is used to determine the type of interactive resize (touch, pointer, etc).

The server may ignore resize requests depending on the state of the surface (e.g. fullscreen or maximized).

If triggered, the client will receive configure events with the "resize" state enum value and the expected sizes. See the "resize" enum value for more details about what is required. The client must also acknowledge configure events using "ack_configure". After the resize is completed, the client will receive another "configure" event without the resize state.

If triggered, the surface also will lose the focus of the device (wl_pointer, wl_touch, etc) used for the resize. It is up to the compositor to visually indicate that the resize is taking place, such as updating a pointer cursor, during the resize. There is no guarantee that the device focus will return when the resize is completed.

The edges parameter specifies how the surface should be resized, and is one of the values of the resize_edge enum. The compositor may use this information to update the surface position for example when dragging the top left corner. The compositor may also use this information to adapt its behavior, e.g. choose an appropriate cursor image.

Definition at line 10006 of file wayland-client-protocol-unstable.cpp.

## set_app_id()

void zxdg_toplevel_v6_t::set_app_id | ( | std::string const & | app_id | ) |

set application ID

Parameters

  app_id |

Set an application identifier for the surface.

The app ID identifies the general class of applications to which the surface belongs. The compositor can use this to group multiple surfaces together, or to determine how to launch a new application.

For D-Bus activatable applications, the app ID is used as the D-Bus service name.

The compositor shell will try to group application surfaces together by their app ID. As a best practice, it is suggested to select app ID's that match the basename of the application's .desktop file. For example, "org.freedesktop.FooViewer" where the .desktop file is "org.freedesktop.FooViewer.desktop".

See the desktop-entry specification [0] for more details on application identifiers and how they relate to well-known D-Bus names and .desktop files.

[0] http://standards.freedesktop.org/desktop-entry-spec/

Definition at line 9988 of file wayland-client-protocol-unstable.cpp.

## set_fullscreen()

void zxdg_toplevel_v6_t::set_fullscreen | ( | output_t const & | output | ) |

set the window as fullscreen on a monitor

Parameters

  output |

Make the surface fullscreen.

You can specify an output that you would prefer to be fullscreen. If this value is NULL, it's up to the compositor to choose which display will be used to map this surface.

If the surface doesn't cover the whole output, the compositor will position the surface in the center of the output and compensate with black borders filling the rest of the output.

Definition at line 10036 of file wayland-client-protocol-unstable.cpp.

## set_max_size()

void zxdg_toplevel_v6_t::set_max_size | ( | int32_t | width,
|  | int32_t | height
| ) |  |

set the maximum size

Parameters

  width |
  height |

Set a maximum size for the window.

The client can specify a maximum size so that the compositor does not try to configure the window beyond this size.

The width and height arguments are in window geometry coordinates. See xdg_surface.set_window_geometry.

Values set in this way are double-buffered. They will get applied on the next commit.

The compositor can use this information to allow or disallow different states like maximize or fullscreen and draw accurate animations.

Similarly, a tiling window manager may use this information to place and resize client windows in a more effective way.

The client should not rely on the compositor to obey the maximum size. The compositor may decide to ignore the values set by the client and request a larger size.

If never set, or a value of zero in the request, means that the client has no expected maximum size in the given dimension. As a result, a client wishing to reset the maximum size to an unspecified state can use zero for width and height in the request.

Requesting a maximum size to be smaller than the minimum size of a surface is illegal and will result in a protocol error.

The width and height must be greater than or equal to zero. Using strictly negative values for width and height will result in a protocol error.

Definition at line 10012 of file wayland-client-protocol-unstable.cpp.

## set_maximized()

void zxdg_toplevel_v6_t::set_maximized | ( |  | ) |

maximize the window

Maximize the surface.

After requesting that the surface should be maximized, the compositor will respond by emitting a configure event with the "maximized" state and the required window geometry. The client should then update its content, drawing it in a maximized state, i.e. without shadow or other decoration outside of the window geometry. The client must also acknowledge the configure when committing the new content (see ack_configure).

It is up to the compositor to decide how and where to maximize the surface, for example which output and what region of the screen should be used.

If the surface was already maximized, the compositor will still emit a configure event with the "maximized" state.

Definition at line 10024 of file wayland-client-protocol-unstable.cpp.

## set_min_size()

void zxdg_toplevel_v6_t::set_min_size | ( | int32_t | width,
|  | int32_t | height
| ) |  |

set the minimum size

Parameters

  width |
  height |

Set a minimum size for the window.

The client can specify a minimum size so that the compositor does not try to configure the window below this size.

The width and height arguments are in window geometry coordinates. See xdg_surface.set_window_geometry.

Values set in this way are double-buffered. They will get applied on the next commit.

The compositor can use this information to allow or disallow different states like maximize or fullscreen and draw accurate animations.

Similarly, a tiling window manager may use this information to place and resize client windows in a more effective way.

The client should not rely on the compositor to obey the minimum size. The compositor may decide to ignore the values set by the client and request a smaller size.

If never set, or a value of zero in the request, means that the client has no expected minimum size in the given dimension. As a result, a client wishing to reset the minimum size to an unspecified state can use zero for width and height in the request.

Requesting a minimum size to be larger than the maximum size of a surface is illegal and will result in a protocol error.

The width and height must be greater than or equal to zero. Using strictly negative values for width and height will result in a protocol error.

Definition at line 10018 of file wayland-client-protocol-unstable.cpp.

## set_minimized()

void zxdg_toplevel_v6_t::set_minimized | ( |  | ) |

set the window as minimized

Request that the compositor minimize your surface. There is no way to know if the surface is currently minimized, nor is there any way to unset minimization on this surface.

If you are looking to throttle redrawing when minimized, please instead use the wl_surface.frame event for this, as this will also work with live previews on windows in Alt-Tab, Expose or similar compositor features.

Definition at line 10048 of file wayland-client-protocol-unstable.cpp.

## set_parent()

void zxdg_toplevel_v6_t::set_parent | ( | zxdg_toplevel_v6_t const & | parent | ) |

set the parent of this surface

Parameters

  parent |

Set the "parent" of this surface. This window should be stacked above a parent. The parent surface must be mapped as long as this surface is mapped.

Parent windows should be set on dialogs, toolboxes, or other "auxiliary" surfaces, so that the parent is raised when the dialog is raised.

Definition at line 9976 of file wayland-client-protocol-unstable.cpp.

## set_queue()

void wayland::proxy_t::set_queue | ( | event_queue_t | queue | ) |

inherited

Assign a proxy to an event queue.

Parameters

  queue | The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
  proxy_wrapper.cpp.

## set_title()

void zxdg_toplevel_v6_t::set_title | ( | std::string const & | title | ) |

set surface title

Parameters

  title |

Set a short title for the surface.

This string may be used to identify the surface in a task bar, window list, or other user interface elements provided by the compositor.

The string must be encoded in UTF-8.

Definition at line 9982 of file wayland-client-protocol-unstable.cpp.

## show_window_menu()

void zxdg_toplevel_v6_t::show_window_menu | ( | seat_t const & | seat,
|  | uint32_t | serial,
|  | int32_t | x,
|  | int32_t | y
| ) |  |

show the window menu

Parameters

  seat | the wl_seat of the user event
  serial | the serial of the user event
  x | the x position to pop up the window menu at
  y | the y position to pop up the window menu at

Clients implementing client-side decorations might want to show a context menu when right-clicking on the decorations, giving the user a menu that they can use to maximize or minimize the window.

This request asks the compositor to pop up such a window menu at the given position, relative to the local surface coordinates of the parent surface. There are no guarantees as to what menu items the window menu contains.

This request must be used in response to some sort of user action like a button press, key press, or touch down event.

Definition at line 9994 of file wayland-client-protocol-unstable.cpp.

## unset_maximized()

void zxdg_toplevel_v6_t::unset_maximized | ( |  | ) |

unmaximize the window

Unmaximize the surface.

After requesting that the surface should be unmaximized, the compositor will respond by emitting a configure event without the "maximized" state. If available, the compositor will include the window geometry dimensions the window had prior to being maximized in the configure request. The client must then update its content, drawing it in a regular state, i.e. potentially with shadow, etc. The client must also acknowledge the configure when committing the new content (see ack_configure).

It is up to the compositor to position the surface after it was unmaximized; usually the position the surface had before maximizing, if applicable.

If the surface was already not maximized, the compositor will still emit a configure event without the "maximized" state.

Definition at line 10030 of file wayland-client-protocol-unstable.cpp.

## Member Data Documentation

## move_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::move_since_version = 1

static constexpr

Minimum protocol version required for the move function.

Definition at line 8399 of file wayland-client-protocol-unstable.hpp.

## resize_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::resize_since_version = 1

static constexpr

Minimum protocol version required for the resize function.

Definition at line 8442 of file wayland-client-protocol-unstable.hpp.

## set_app_id_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::set_app_id_since_version = 1

static constexpr

Minimum protocol version required for the set_app_id function.

Definition at line 8346 of file wayland-client-protocol-unstable.hpp.

## set_fullscreen_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::set_fullscreen_since_version = 1

static constexpr

Minimum protocol version required for the set_fullscreen function.

Definition at line 8607 of file wayland-client-protocol-unstable.hpp.

## set_max_size_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::set_max_size_since_version = 1

static constexpr

Minimum protocol version required for the set_max_size function.

Definition at line 8488 of file wayland-client-protocol-unstable.hpp.

## set_maximized_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::set_maximized_since_version = 1

static constexpr

Minimum protocol version required for the set_maximized function.

Definition at line 8560 of file wayland-client-protocol-unstable.hpp.

## set_min_size_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::set_min_size_since_version = 1

static constexpr

Minimum protocol version required for the set_min_size function.

Definition at line 8534 of file wayland-client-protocol-unstable.hpp.

## set_minimized_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::set_minimized_since_version = 1

static constexpr

Minimum protocol version required for the set_minimized function.

Definition at line 8634 of file wayland-client-protocol-unstable.hpp.

## set_parent_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::set_parent_since_version = 1

static constexpr

Minimum protocol version required for the set_parent function.

Definition at line 8297 of file wayland-client-protocol-unstable.hpp.

## set_title_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::set_title_since_version = 1

static constexpr

Minimum protocol version required for the set_title function.

Definition at line 8315 of file wayland-client-protocol-unstable.hpp.

## show_window_menu_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::show_window_menu_since_version = 1

static constexpr

Minimum protocol version required for the show_window_menu function.

Definition at line 8371 of file wayland-client-protocol-unstable.hpp.

## unset_fullscreen_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::unset_fullscreen_since_version = 1

static constexpr

Minimum protocol version required for the unset_fullscreen function.

Definition at line 8616 of file wayland-client-protocol-unstable.hpp.

## unset_maximized_since_version

constexpr std::uint32_t wayland::zxdg_toplevel_v6_t::unset_maximized_since_version = 1

static constexpr

Minimum protocol version required for the unset_maximized function.

Definition at line 8587 of file wayland-client-protocol-unstable.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.hpp
- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.cpp
- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.cpp